package
{
	import flash.display.BitmapData;
	import flash.events.ErrorEvent;
	import flash.utils.Dictionary;

	import starling.core.Starling;
	import starling.display.DisplayObjectContainer;
	import starling.display.Image;
	import starling.text.BitmapFont;
	import starling.text.TextField;
	import starling.text.TextFieldAutoSize;
	import starling.text.TextFormat;
	import starling.textures.Texture;

	public class Game extends DisplayObjectContainer
	{

		[Embed(source="/../assets/image-1.jpg")]
		private var IMAGE1:Class;
		[Embed(source="/../assets/image-2.jpg")]
		private var IMAGE2:Class;
		[Embed(source="/../assets/image-3.jpg")]
		private var IMAGE3:Class;
		[Embed(source="/../assets/image-4.jpg")]
		private var IMAGE4:Class;

		private var mCounter:int;
		private var mCounterTxt:TextField;
		private var mImages:Dictionary;

		public function Game()
		{
			super();

			mImages = new Dictionary();
			mImages["image-1"] = new IMAGE1();
			mImages["image-2"] = new IMAGE2();
			mImages["image-3"] = new IMAGE3();
			mImages["image-4"] = new IMAGE4();
		}

		public function init():void
		{
			Texture.asyncBitmapUploadEnabled = true;

			mCounterTxt = new TextField(1, 1, "0", new TextFormat(BitmapFont.MINI, -1, 0xFFFFFF));
			mCounterTxt.autoSize = TextFieldAutoSize.BOTH_DIRECTIONS;
			addChild(mCounterTxt);

			uploadTexture("image-1");
			uploadTexture("image-2");
			uploadTexture("image-3");
			uploadTexture("image-4");
		}


		private function uploadTexture(name:String):void
		{
			var bmpData:BitmapData = mImages[name].bitmapData;

			Texture.fromBitmapData(bmpData, false, false, 2, "bgra", false, function(texture:Texture, error:ErrorEvent):void
			{
				mCounter++;

				var image:Image = new Image(texture);
				image.name = name;
				image.height = Main.height * 0.9;
				image.scaleX = image.scaleY;
				image.x = (Main.width - image.width) * Math.random();
				image.y = Main.height * 0.05;
				var childIndex:int = (numChildren * Math.random()) + 1;
				addChildAt(image, childIndex);

				mCounterTxt.text = String(mCounter);

				Starling.juggler.delayCall(disposeImage, 0.15, image);
			});
		}


		private function disposeImage(image:Image):void
		{
			image.texture.dispose();
			image.removeFromParent(true);

			Starling.juggler.delayCall(uploadTexture, 0.15, image.name);
		}

	}

}
