package {

	import feathers.utils.ScreenDensityScaleFactorManager;

	import flash.desktop.NativeApplication;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageDisplayState;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.utils.clearInterval;
	import flash.utils.setTimeout;

	import starling.core.Starling;
	import starling.events.Event;
	import starling.utils.SystemUtil;

	[SWF(frameRate="60", backgroundColor="#000000")]
    public class Main extends Sprite {

        private var mStarling:Starling;
        private var mScaleManager:ScreenDensityScaleFactorManager;
        private var mTimeoutId:int = -1;

        private static var sStageWidth:Number = 0;
        private static var sStageHeight:Number = 0;

        public function Main() {
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;
            stage.displayState = StageDisplayState.FULL_SCREEN_INTERACTIVE;

            stage.addEventListener( "resize", onStageResize );
        }

        private function onStageResize( event:flash.events.Event ):void {
            if( mTimeoutId != -1 ) {
                clearInterval( mTimeoutId );
            }
            mTimeoutId = setTimeout( init, 50 );
        }

        private function init():void {
            stage.removeEventListener( "resize", onStageResize );

            mStarling = new Starling( Game, stage );
            mScaleManager = new ScreenDensityScaleFactorManager(mStarling);
            mStarling.showStatsAt( "right", "bottom" );
            mStarling.addEventListener( starling.events.Event.ROOT_CREATED, onStarlingReady );

            mStarling.start();

            // When the game becomes inactive, we pause Starling; otherwise, the enter frame event
            // would report a very long 'passedTime' when the app is reactivated.

            if( !SystemUtil.isDesktop ) {
                NativeApplication.nativeApplication.addEventListener(
                        flash.events.Event.ACTIVATE, function ( e:* ):void {
                            mStarling.start();
                        } );
                NativeApplication.nativeApplication.addEventListener(
                        flash.events.Event.DEACTIVATE, function ( e:* ):void {
                            mStarling.stop( true );
                        } );
            }
        }

        private function onStarlingReady(event:starling.events.Event, root:Game):void {
            trace("Ready", root);

            sStageWidth = mStarling.stage.stageWidth;
            sStageHeight = mStarling.stage.stageHeight;

            root.init();
        }

        public static function get width():Number {
            return sStageWidth;
        }

        public static function get height():Number {
            return sStageHeight;
        }

    }

}
